//*****************************************
// IV-27 VFD Clock Program Mega328
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
//
// File Name:infrared.c
//
//  2018/04/04 New(TAB4)  Taishi  [Ver 0.1] pro_four_in18_clock [Ver 2.00]iv_27clock
//  2018/10/17 modify     Taishi  IV-21 PipepɕύX
//*****************************************
#include	<avr/io.h>

#include	"pr_iv21_pipe.h"
#include	"timer.h"
#include	"uart.h"
#include	"infrared.h"

unsigned short	Ginf_data;						// Mf[^ifobOpj
unsigned char	inf_data[5] = {0,0,0,0,0};
unsigned char	n_of_infd = 0;					// ŏ牽ԊOf[^󂯎ĂȂ͂OAxł󂯎΂PȏɂȂ


//*****************************************
// ԊORfq Initial
//  荞ݕs̏ԂŌĂ΂Ƃ
//
//*****************************************
void	infrared_init(void)
{
	DDRD &= ~((1 << DDD0));		// Port-D Bit0 : Intput
//	PORTD |= ((1 << PD0) );		// Port-D Bit0 : ORƕɂȂƕׂd݂Ȃ̂ Pullup ͂߂

	uart_init();				// UART ݒ
}
//***************************
//  ԊORfqԂ
//   ocOFk   M ߂lP
//   ocOFg MȂ ߂lO
//***************************
unsigned char	get_infrared_stat(void)
{
	unsigned char	r = 0;

	if((PIND & (1 << PIND0)) == 0){			//ԊORfqԂ擾
		r = 1;
	}

	return(r);
}
//***************************
//  ԊORfqf[^
//    VAʐMf[^ 's',data1,data2, 'e' ̂Sf[^Ƃ
//    Yf[^ȊOM͍܂ł̃f[^jAX^[gf[^҂ɂȂ
//   ߂l
//		OOO			f[^
//		IND1_ON_NOW			set n߂	'1'
//		IND1_ON_CONTINUE	set A		'2'
//		IND1_OFF_SHORT		set Z		'3'
//		IND1_OFF_LONG		set 		'4'
//		IND2_ON_NOW			select n߂	'5'
//		IND2_ON_CONTINUE	select A		'6'
//		IND2_OFF_SHORT		select Z	'7'
//		IND2_OFF_LONG		select 	'8'
//***************************
enum WAIT_STATE {			// f[^҂[h
		WAIT_START_D = 0,	// X^[gf[^҂
		WAIT_DATA1,			// P҂
		WAIT_DATA2,			// Q҂
		WAIT_END_D,			// Ghf[^҂
	};
#define	START_D	's'
#define	END_D	'e'

unsigned char	get_infrared_data(void)
{
	unsigned char			r = 0;
	static unsigned char	st = WAIT_START_D;
	static unsigned char	uc = 0;

	r = Get_rxd(&uc);

	if(r != 0){									// Mf[^L
		Ginf_data = uc;							// fobOpf[^ɓ
		tim_10ms_infrared = 10;					// kdc_
		r = 0;
		switch(st){
		 case WAIT_START_D:						// X^[gf[^҂
			if(uc == START_D){					//  X^[gf[^̎
				inf_data[0] = uc;
				st = WAIT_DATA1;
				n_of_infd = 1;					// LMԊOf[^
			}
			break;
		 case WAIT_DATA1:						// f[^P҂
			if((INFR_DATA_START < uc) && (uc < INFR_DATA_END)){	//  f[^P͈͓̔̎
				inf_data[1] = uc;				//   f[^Pۑ
				st = WAIT_DATA2;				//   f[^Q҂ɂ
				n_of_infd = 2;					// LMԊOf[^
			}else{								//  ͈͊O̎
				st = WAIT_START_D;				//   X^[gf[^҂ɖ߂
			}
			break;
		 case WAIT_DATA2:						// f[^Q҂
			if((INFR_DATA_START < uc) && (uc < INFR_DATA_END)){	//  f[^Q͈͓̔̎
				inf_data[2] = uc;				//   f[^Qۑ
				st = WAIT_END_D;				//   Ghf[^҂ɂ
				n_of_infd = 3;					// LMԊOf[^
			}else{								//  ͈͊O̎
				st = WAIT_START_D;				//   X^[gf[^҂ɖ߂
			}
			break;
		 case WAIT_END_D:						// Ghf[^҂
			if(uc == END_D){					//  Ghf[^̎
				inf_data[3] = uc;
				n_of_infd = 4;					// LMԊOf[^
				st = WAIT_START_D;
				if(inf_data[1] == inf_data[2]){	//  f[^PƂQ
					r = inf_data[1];			//   ߂lZbg
				}
			}else{								//  Ghf[^ȊO̎
				st = WAIT_START_D;				//   X^[gf[^҂ɖ߂
			}
			break;
		 default:								// ̑̑҂iւ͗Ȃj
			st = WAIT_START_D;
			break;
		}
	}

	return(r);
}

